## multipath-tools-0.3.5.tar.bz2

=== Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>

BUILD = klibc

KERNEL_BUILD = /lib/modules/$(shell uname -r)/build

ifeq ($(strip $(BUILD)),klibc)
	BUILDDIRS = libsysfs libdevmapper libcheckers \
		    libmultipath \
		    devmap_name multipath multipathd kpartx
else
	BUILDDIRS = libsysfs libmultipath libcheckers \
		    devmap_name multipath multipathd kpartx
endif

VERSION = $(shell basename ${PWD} | cut -d'-' -f3)
INSTALLDIRS = devmap_name multipath multipathd kpartx

all: recurse

recurse:
	@if [ $(BUILD) = klibc ]; then\
	ln -s ${KERNEL_BUILD} klibc/linux ; \
	$(MAKE) -C klibc ; \
	fi
	@for dir in $(BUILDDIRS); do\
	$(MAKE) -C $$dir $(BUILD) BUILD=$(BUILD) VERSION=$(VERSION); \
	done

recurse_clean:
	@for dir in $(BUILDDIRS); do\
	$(MAKE) -C $$dir clean ; \
	done
	$(MAKE) -C klibc spotless

recurse_install:
	@for dir in $(INSTALLDIRS); do\
	$(MAKE) -C $$dir install ; \
	done

recurse_uninstall:
	@for dir in $(INSTALLDIRS); do\
	$(MAKE) -C $$dir uninstall ; \
	done

clean:	recurse_clean
	rm -f klibc/linux
	rm -rf rpms
	rm -rf debian/tmp debian/stampdir

install:	recurse_install

uninstall:	recurse_uninstall

release:
	sed -e "s/__VERSION__/${VERSION}/" \
	multipath-tools.spec.in > multipath-tools.spec
	sed -e "s/__VERSION__/${VERSION}/" \
	debian/changelog.in > debian/changelog

rpm: release
	rpmbuild -bb multipath-tools.spec

deb: release
	dpkg-buildpackage

=== devmap_name/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
BUILD = klibc

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS} -I../libdevmapper
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes \
		 -DDEBUG=$(DEBUG)
	LDFLAGS = -ldevmapper
endif

EXEC = devmap_name
OBJS = devmap_name.o

all: klibc

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
klibc: prepare $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(DMLIB)-$(BUILD).a \
	$(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	install -d $(DESTDIR)$(mandir)
	install -m 644 $(EXEC).8.gz $(DESTDIR)$(mandir)

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/$(EXEC).8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== dmadm/Makefile ===
BUILD = klibc

EXEC = dmadm

OBJS = util.o dmadm.o

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS =  ${REQFLAGS} ${OPTFLAGS} -I../libsysfs \
		  -I../libdevmapper
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes \
		 -DDEBUG=$(DEBUG)
	LDFLAGS = -ldevmapper -lsysfs
endif

all: klibc

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(STRIP) $(EXEC)

klibc: prepare $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(SYSFSLIB)-$(BUILD).a \
	$(DMLIB)-$(BUILD).a $(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)

clean:
	rm -f $(OBJS) *.o $(EXEC) *~

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)

$(OBJS): mdadm.h

=== kpartx/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD=klibc

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS} -I../libdevmapper -I.
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes -I.
	LDFLAGS = -ldevmapper
endif

EXEC = kpartx
OBJS = bsd.o dos.o kpartx.o solaris.o unixware.o gpt.o crc32.o lopart.o xstrncpy.o

all: klibc

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(STRIP) $(EXEC)
#	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
klibc: prepare $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(DMLIB)-$(BUILD).a \
	$(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)
#	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/

uninstall:
	rm $(DESTDIR)$(bindir)/$(EXEC)

clean:
	rm -f core *.o $(EXEC) *.gz

=== libcheckers/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD = klibc

include ../Makefile.inc

OBJS = readsector0.o tur.o selector.o checkers.o emc_clariion.o

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS}
else
	CFLAGS =
endif

all: klibc

prepare:
	rm -f core *.o *.gz

klibc: prepare $(OBJS)
	ar rs libcheckers-klibc.a *.o

glibc: prepare $(OBJS)
	ar rs libcheckers-glibc.a *.o

install:

uninstall:

clean:
	rm -f core *.a *.o *.gz

=== libdevmapper/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>

include ../Makefile.inc

CFLAGS += -I. -Iioctl -Iinclude ${REQFLAGS} ${OPTFLAGS}

OBJS = ioctl/libdm-iface.o libdm-common.o

klibc:	$(OBJS)
	ar rs libdevmapper-klibc.a *.o ioctl/*.o

all: klibc

install:

uninstall:

clean:
	rm -f core *.o ioctl/*.o ioctl/*.so *.a

=== libmultipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
#
BUILD = glibc

include ../Makefile.inc

OBJS = memory.o parser.o vector.o

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS}
else
	CFLAGS =
endif

prepare:
	rm -f core *.o *.gz

klibc: prepare $(OBJS)
	ar rs libmultipath-klibc.a *.o

glibc: prepare $(OBJS)
	ar rs libmultipath-glibc.a *.o

all: klibc

install:

uninstall:

clean:
	rm -f core *.a *.o *.gz

=== libsysfs/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS}
else
	CFLAGS =
endif

OBJS = dlist.o \
       sysfs_dir.o \
       sysfs_utils.o

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	ar rs libsysfs-glibc.a *.o
	
klibc: prepare $(OBJS)
	ar rs libsysfs-klibc.a *.o

all: klibc

install:

uninstall:

clean:
	rm -f core *.a *.o *.gz

=== multipath/Makefile ===
# Makefile
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@free.fr>
BUILD = klibc

include ../Makefile.inc

ifeq ($(strip $(BUILD)),klibc)
	CFLAGS = ${REQFLAGS} ${OPTFLAGS} -DDEBUG=${DEBUG} \
		 -DVERSION=$(VERSION) -I$(multipathdir) \
		 -I$(libdmdir) -I$(sysfsdir) -I$(checkersdir)
else
	CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes \
		 -DDEBUG=$(DEBUG) -I$(multipathdir) -I$(checkersdir) \
		 -DVERSION=$(VERSION)
	LDFLAGS = -ldevmapper -lsysfs
endif

EXEC = multipath
DEBUG = 0

OBJS = pgpolicies.o devinfo.o main.o callout.o dict.o \
       $(MULTIPATHLIB)-$(BUILD).a \
       $(CHECKERSLIB)-$(BUILD).a

all: klibc

prepare:
	rm -f core *.o *.gz

glibc: prepare $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz
	
klibc: prepare $(OBJS)
	$(LD) -o $(EXEC) $(CRT0) $(OBJS) $(SYSFSLIB)-$(BUILD).a \
	$(DMLIB)-$(BUILD).a $(CHECKERSLIB)-$(BUILD).a $(KLIBC) $(LIBGCC)
	$(STRIP) $(EXEC)
	$(GZIP) $(EXEC).8 > $(EXEC).8.gz

$(CHECKERSLIB)-$(BUILD).a:
	make -C $(checkersdir) BUILD=$(BUILD) $(BUILD)

$(MULTIPATHLIB)-$(BUILD).a:
	make -C $(multipathdir) BUILD=$(BUILD) $(BUILD)

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	install -d $(DESTDIR)/etc/dev.d/block/
	install -m 755 multipath.dev $(DESTDIR)/etc/dev.d/block/
	install -d $(DESTDIR)/etc/udev/rules.d
	install -m 755 multipath.rules $(DESTDIR)/etc/udev/rules.d/
	install -d $(DESTDIR)$(mandir)
	install -m 644 multipath.8.gz $(DESTDIR)$(mandir)

uninstall:
	rm $(DESTDIR)/etc/dev.d/block/multipath.dev
	rm $(DESTDIR)/etc/udev/rules.d/multipath.rules
	rm $(DESTDIR)$(bindir)/$(EXEC)
	rm $(DESTDIR)$(mandir)/multipath.8.gz

clean:
	rm -f core *.o $(EXEC) *.gz

=== multipathd/Makefile ===
EXEC = multipathd

#
# debug verbosity, same as syslog.h
# nothing to below 5, full debug at 7
#
LOGLEVEL = 5

include ../Makefile.inc

#
# directories where to put stuff
#
bindir = /usr/bin
mandir = /usr/share/man/man8
rcdir = /etc/init.d

#
# basic flags setting
#
CFLAGS = -pipe -g -Wall -Wunused -Wstrict-prototypes -DLOGLEVEL=$(LOGLEVEL) \
	 -DFLOATING_STACKS -I$(multipathdir) -I$(checkersdir) -I$(sysfsdir)
LDFLAGS = -lpthread -ldevmapper

#
# detect arch
#
ARCH = $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
CFLAGS += -D${ARCH}

#
# object files
#
OBJS = main.o copy.o devinfo.o callout.o dict.o \
       $(CHECKERSLIB)-glibc.a \
       $(MULTIPATHLIB)-glibc.a \
       $(SYSFSLIB)-glibc.a

#
# directives
#
all : glibc

glibc: $(EXEC)

klibc: glibc

$(EXEC): $(OBJS)
	$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS)
	strip $(EXEC)

$(CHECKERSLIB)-glibc.a:
	$(MAKE) -C $(checkersdir) BUILD=glibc glibc

$(MULTIPATHLIB)-glibc.a:
	$(MAKE) -C $(multipathdir) BUILD=glibc glibc

$(SYSFSLIB)-glibc.a:
	$(MAKE) -C $(sysfsdir) BUILD=glibc glibc

install:
	install -d $(DESTDIR)$(bindir)
	install -m 755 $(EXEC) $(DESTDIR)$(bindir)
	install -d $(DESTDIR)$(rcdir)
	install -m 755 multipathd.init $(DESTDIR)$(rcdir)/$(EXEC)

uninstall:
	rm -f $(DESTDIR)$(bindir)/$(EXEC)
	rm -f $(DESTDIR)$(rcdir)/$(EXEC)

clean:
	rm -f core *.o $(EXEC) *.gz
	rm -rf libsysfs
	rm -rf libcheckers

=== debian/changelog ===
multipath-tools (0.3.0-1) unstable; urgency=high

  * initial packaging, by upstream maintainer

 -- Christophe Varoqui <christophe.varoqui@free.fr>  Thu, 30 Sep 2004 10:03:23 +0200

=== debian/control ===
Source: multipath-tools
Section: admin
Priority: extra
Maintainer: Christophe Varoqui <christophe.varoqui@free.fr>
Build-Depends: debhelper (>> 4.0.0), po-debconf, bzip2, libnewt-dev, libdevmapper-dev
Standards-Version: 3.6.1

Package: multipath-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hotplug, udev, scsi_id (>= 0.6), initscripts (>= 2.85-16), makedev (>= 2.3.1-70), libdevmapper
Conflicts:
Description: multipathed devices management tools and daemon
 feed me
 feed me
